package LATMOS::Accounts::Task::Automatedrequest;

use strict;
use warnings;
use base qw(LATMOS::Accounts::Task);
use LATMOS::Accounts;
use Config::IniFiles;
use LATMOS::Accounts::Log;
use LATMOS::Accounts::Utils;

sub init {
    my ($self) = @_;
    my $LA = LATMOS::Accounts->new($self->{config}, noacl => 1);
    my $labase = $self->{base} ? $LA->base($self->{base}) : $LA->default_base;
    $labase && $labase->load or die "Cannot load base";

    $self->{_la} = $LA;
    $self->{_base} = $labase;

    1;
}

sub run {
    my ($self) = @_;

    foreach my $id ($self->{_base}->list_auto_pending_requests) {
        my $datarequest = $self->{_base}->get_datarequest($id) or do {
            $self->{_base}->log(LA_ERR, "Cannot fetch request %d", $id);
            next;
        };
        if ($datarequest->auto_apply_to_object) {
            $datarequest->base->commit;
        }
    }

    1;
}

1;
